Subject: Linux-Activists Digest #93
From: Digestifier <[email-masked]>
To: [email-masked]
Date: Wed, 22 Apr 92 12:15:26 EDT

Linux-Activists Digest #93, Volume #2            Wed, 22 Apr 92 12:15:26 EDT

Contents:
  ln,mv, i_nlinks incorrect (Stephen Gallimore)
  Re: timezone support, date, CMOS clock support: archive sites please note (Greg Lee)
  pre-0.96 release at tsx-11... (Michael K. Johnson)
  Re: Miscellaneous questions. (Rogier Wolff)
  FAQ: List of queries (Marc CORSINI)

----------------------------------------------------------------------------

From: Stephen Gallimore <[email-masked]>
Subject: ln,mv, i_nlinks incorrect
Reply-To: [email-masked]
Date: Wed, 22 Apr 1992 14:04:45 GMT

During upgrading linux to 0.95c+/gcc2.1 beta I discovered a bug in the
file system regarding hard links. Someone who knows the minix fs code
might like to take a look at this before 0.96 is released.

Ok, do a fsck -r and clear any errors (I tend to get quite a few unused
but marked zones after only a few hours of kernel recompilations, there
are clearly other problems in the fs other than the one I will describe, the
moral is use fsck regularly or run out of disk space !)

1) create 'afile' with some text in it, doesn't matter what.

2) ln afile bfile

3) create 'cfile' again with something in.

4) mv cfile afile

if you now do an ls -l bfile you will see that it still reports two links.
Run fsck again (not -r yet!) and you should see
Inode x, i_nlinks=2,counted=1
Now this is obviously wrong, the link count on bfile should be 1 not 2.

5) rm bfile

bfile now gets removed from the directory, but its inode and zones haven't
been released as the fs still thinks there is another link to it. Running
fsck gives
Inode x not used,marked in bitmap
Inode x i_nlinks=1,counted=0
Zone x: marked in use, no file uses it

At this point I thought this was a general problem with the rename system
call and this was the source of all the marked but unused zones that keep
cropping up, however I had never seen the Inode messages before. It turns
out that moving over a file with no other links, i.e. i_nlinks=1, works fine.

I took a quick look at fs/minix/rename.c to see if I could spot an error,
but from what I can see it looks alright there is an ->i_nlinks-- done
on one of the inodes it works with. I shall investigate futher when I have
the time but I think it would be better if someone who was familiar with
the code looked at it (its a bit messy) so that it might get fixed in the
next release.

Cheers,
Stephen

:Stephen Gallimore:E-Mail [email-masked]:Tel (+44) 532 335730:

------------------------------

From: [email-masked] (Greg Lee)
Subject: Re: timezone support, date, CMOS clock support: archive sites please note
Date: Wed, 22 Apr 1992 13:52:29 GMT

In article <[email-masked]> [email-masked] (Kevin Cummings) writes:
}I happend to find timebin.tar.Z on tsx-11 yesterday, and downloaded
}...
}Something's not right here.

Yes, something is not.  I set the clock and the date with the new
programs 'clock' and 'date', and it seemed to work ok.  'date' did
mention the time zone (HST, -10 from GMT).  But at the next reboot,
the 'clock -s' I had put in /etc/rc didn't set the date and gave
an error message that I probably wasn't root.  I was root, but 'clock'
was suid bin and /dev/port was owned by bin.  I had to change 'clock'
to suid root to get it to work.  Time passed.  After the next reboot
and 'clock -s' executed from /etc/rc, 'clock' said it was
        Sun 4/21 15:21, but 'date' claimed it was
        Tue 4/21 05:21.  It was actually Tue 4/21 15:21.  So I did
another 'clock -s', and then I got
        Sun 4/21 15:22 from 'clock', and
        Tue 4/21 15:22 from 'date'.  That's correct, except 'clock'
still displays the wrong day-of-week.  After 'clock -w', 'clock' and
'date' finally both displayed the correct date and time.  Whew.

--
Greg Lee <[email-masked]>

------------------------------

From: [email-masked] (Michael K. Johnson)
Subject: pre-0.96 release at tsx-11...
Reply-To: [email-masked] (Michael K. Johnson)
Date: Wed, 22 Apr 1992 15:28:11 GMT

Linus has put a pre-release for .96 on tsx-11, and it is available as
tsx-11.mit.edu:/pub/linux/sources/system/pre-0.96.tar.Z
and
tsx-11.mit.edu:/pub/linux/sources/system/linux-0.95c++.tar.Z
(sorry, I couldn't resist...)

michaelkjohnson
[email-masked]

------------------------------

From: [email-masked] (Rogier Wolff)
Crossposted-To: alt.os.linux
Subject: Re: Miscellaneous questions.
Date: 22 Apr 92 13:08:13 GMT

>[email-masked] (Scott Dunn) writes:

>I'd like to ask the same question:

>>2.    What is a working version of tar and un/compress?
>>      A lot of problems seem to be solved by getting new versions of the
>>      aforementioned.  However, nobody has indicated how to identify which
>>      are the dodgy copies.
>>      Sometimes when uncompressing it seems to get stuck in an infinite
>>      loop which takes all system resources.  ie I can't login to another
>>      terminal and kill the process.  Is this what is known as a 'race
>>      condition' ?  Is this indicate a dodgy copy of un/compress ?

>How can I fix these problems ?
>What's the reason ?

Compress starts to use memrory that it hasn't allocated when it gets
invalid input. Most unices will then give it a "segment violation" and
kill it. Linux currently simply allocates the memory, and lets the 
application continue. This will be fixed in the future. (if nobody
else does it, I will.)

                                        Roger.

-- 
If the opposite of "pro" is "con", what is the opposite of "progress"? 
        (stolen from  [email-masked])
EMail:  [email-masked]   ** Tel  +31-15-783644 or +31-15-142371

------------------------------

From: [email-masked] (Marc CORSINI)
Subject: FAQ: List of queries
Reply-To: [email-masked] (Marc CORSINI)
Date: Wed, 22 Apr 1992 16:01:09 GMT

I. LINUX GENERAL INFORMATION 
=============================
  1)  What is linux?
  2)  What is the current state of Linux?
  3)  I've just heard about linux, what should I do to get it?
  4)  Does it run on my computer?
  5)  Why the suggested 4Meg, for Linux?
  6)  How would this operate in an OS/2 environment?
  7)  Will linux run on a PC or 286-AT? If not, why?
  8)  Will Linux run on a 386 Laptop?
  9)  How big is the 'complete' Linux package?
 10)  (Dan) How long has Linux been publicly available?
 11)  What's about the copyright of linux.
 12)  Should I be a UNIX and/or a DOS wizard to install/use Linux?
 13)  What are the differences, pros and cons compared to Minix ?
 14)  Does Linux use TSS segments to provide multitasking?
 15)  If my PC runs under Linux, is it possible to ftp, rlogin,
rsh etc.. to other Unix boxes?
 16)  Does linux do paging? Can I have virtual memory on my small
machine?
 17)  Can I have tasks spanning the full 4GB of addressable 386
memory? No more 64kB limits like in coherent or standard minix?
 18)  Does the bigger program sizes mean I can run X?

II. LINUX USEFUL ADDRESSES 
=========================
 19)  Where can I get linux?
 20)  I do not have FTP access, what can I do to get linux?
 21)  Is there a newsgroup or mailing-list about linux? Where can
I get my questions answered? How about bug-reports?
 22)  Does there exist a place where the traffic of the newsgroup
is kept?

III. INSTALLATION and SECURITY 
==============================
 23)  Does there exist *any* reliable information that can help me
to install Linux, 'cause I know very few things about Dos and/or Unix?
 24)  Does there exists a simple way to get all (or nearly) the
Linux stuff? 
 25)  What are the files provided in the interim distrib?
 26)  Ok, I've got the interim distribution, what should I do now?
 27)  I have copyed all the rootimage stuff on my HD, how can I
use the hard-disk as root?
 28)  How can I be sure I won't be writing over anything
important?  I have to use DOS on my machine, and I don't want to
lose any files.
 29)  Linux mkfs doesn't accept the size I give the device,
although I double-checked with fdisk, and it's correct.
 30)  I have a one partitionned 40Mb disk. If I run mkfs, what
happens?
 31)  I mounted the linux filesystem, and copied the files from
the root-disk to the harddisk. Now I cannot find them any more, and
somethimes linux dies with a "panic: trying to free unused inode".

IV. LINUX and DOS 
=================
 32)  Is it possible to access to DOS world from Linux
 33)  the mtools package won't work. I get an ENOENT error message
for all devices.
 34)  Whenever I use mtools to read a 720K in an 1.44MB drive, I
get a long sequence of reset-floppy-errors, why? 
 35)  What is as86.tar.Z ?
 36)  Turbo (Microsoft) Assembler won't compile the Linux boot
code.  In fact, some of the opcodes in these files look completely
unfamiliar.  Why?

V. SOME CLASSICAL PROBLEMS 
==========================
 37)  While running du I get "Kernel panic: free_inode: bit
already cleared".  Also, du produces a ENOENT error for all the files
in certain of my directories.  What's going on?
 38)  How can I partition my hard-drive to use Linux?
 39)  What must I do to mkfs a floppy?
 40)  When I run kermit under Linux, I get "Warning, Read access
to lock directory denied". What am I doing wrong?
 41)  du works just fine on directories, except on / and /dev,
moreover "ls -l" returns either big or negative number on /dev. Why?
 42)  When I try to (un)compress many files in one command, the
command partially fails?
 43)  I can do this as root but not as non-root, is it a bug?
 44)  When I use make as non root, it doesn't work, why?
 45)  Sometimes, I get "mount can't open lock file"; what does this
means? 
 46)  When I try "mount /dev/hd?? /user", I get error 2.

VI. INSTALLATION HINTS 
======================
 47)  Where can I find the basic starting help?
 48)  I've got all the things on site ??? but I don't know what
goes where.
 49)  When I use the images, and I type "tar xvf ..." I got
"command not found". What did I wrong?
 50)  It seems that $#@! ported on linux don't run correctly
 51)  Does anyone port this to linux?, if not i'll compile it
 52)  I've ported *** to Linux, what should i do to add it in the 
standard distribution?
 53)  I want to port *** to Linux, what are the flags?
 54)  Linux lacks on ****/ Linux has a bug in ***, what are the
rules to enhance/correct the kernel?
 55)  What are the device minor/major numbers?
 56)  How to start Linux from drive B?
 57)  The program boot_b works fine /but/ once the first disk is
read the system go back to the first drive, any hints?

VII. FEATURES 
=============
 58)  I've read that linux has virtual consoles, what must I do to
get them?
 59)  What kind of shell is /bin/sh ?
 60)  I've been able to install Linux on my box, but Ctrl-Z nor
switching jobs from background to foreground seem to work, why?
 61)  Does there exist a man page for **** ?
 62)  What are the editors available in linux?
 63)  Does there exist a printer package for Linux?
 64)  Does there exist a ps for Linux?
 65)  It's nice to have the df utility, but it would be nicer if
it would give statistics of the root file system. Would it be
difficult to do?
 66)  How do I make swapping work?
 67)  When I boot I get one of the following messages:
"Unable to find swap signature" or "Bad swap-space bitmap"
 68)  How do I know if it is swapping?
 69)  How is it possible to remove a swap file?
 70)  How is it possible to remove a swap device?
 71)  Is there only the %$#@ keyboard ?
 72)  (special FINNISH/US) I booteed up with the new image and
everything work except that some keyboard keys produce wrong
characters. Does anyone know what is happening?
 73)  Does there exist shared libs ?
 74)  Does Linux permit/support bitmapped graphics on vga/svga 
cards?
 75)  Does Linux work for SCSI drives?
 76)  What SCSI hosts are supported?
 77)  Does these SCSI drives support extended partition?
 78)  Linux is supposed to work with ESDI drive. However I have
trouble with my Magtron MT-4115E (Joincom controler), any clue?
 79)  There are a lot of patches available (fd patch, lp patch
login patch ...) can I be fairly confident the subsequent patches will
work?
 80)  I got the patches on some ftp sites, and applied them to the
kernel and tried to compile. It didn't !!. Are the patches buggy?

VIII. MORE HINTS 
================ 
 81)  How can I backup my Hd under Linux ?
 82)  How to use setterm: for the novice?
 83)  I've tried clear/reset which exist on most of unix but it
doesn't work, have I missed something? 
 84)  I know there are VC, but where is the setterm stuff?
 85)  While using emacs in 80x25 mode, the mode line is constantly
moving around, why?
 86)  How can I get Linux to boot directly from the harddisk?
 87)  Sometimes, when I want to remove a directory, I get an error
message, is it a (known) bug?
 88)  can anyone give me a sample /etc/inittab entry for login
from a pc attached to serial line /dev/ttys2? 
 89)  I've seen the login but I missed the passwd binaries, where
can I find them? 
 90)  I've been trying to get Linux to run on my [3/4]86 box. It
can't even boot. Any suggestions?
 91)  Does there exist games, languages (other than C), and
anything which make the system more friendly?
 92)  Could someone explain how to use rawrite?
 93)  Does emacs handle the arrows-key
 94)  Whenever I use uemacs 3.1X on a symlink, the symlink does
not exist anymore, why?
 95)  Uemacs doesn't work anymore with 0.95a, whenever I want to
save a file; what can I do?
 96)  I have an SVGA, but Linux detect an EGAc/EGAm; is it normal?
 97)  How can I change the keyboard repeat rate?

IX. GCC MISC INFORMATION
========================
 98)  I don't know how to install gcc stuff, is there special
places?
 99)  I seem to be unable to compile anything with gcc. Why?
100)  I'm using a program that uses signal handlers which are
installed using sigaction() with the SA_NOMASK, and they get a general
protection error right after the signal handler tries to return.
What's going wrong?
101)  gcc complains about not finding crt0.o and the system
include files What am I doing wrong ?
102)  While compiling some GNU packages gcc chokes on regex.c with
an insn code, what can I do?
103)  I tried to port a /new/ version of gnu stuff. But in the
linking phase, gcc complains about the missing libg.a. In fact it
depends on the gcc package you use.
104)  How to compile programs which may be debugged with gdb?
105)  When compiling some code, cc1 complains about some insn
code, what's that? 
106)  While compiling some stuff, I'm getting the following 
error message:
Undefined symbol ___addsf3 referenced from text segment
as well as ___mulsf3 and __cmpsf2. 
These symbols are not in the program or in it's header files.
107)  What are the enhancement of the newgcc.tar.Z ?
108)  What can gcc-2.x do for me, that gcc-1.40 cannot?
109)  I can't run g++ due to the lack of "expr"; where can I find
it ?

------------------------------

** FOR YOUR REFERENCE **

The service address, to which questions about the list itself and requests
to be added to or deleted from it should be directed, is:

    Internet: [email-masked]

You can send mail to the entire list (and comp.os.linux) via:

    Internet: [email-masked]

Linux may be obtained via one of these FTP sites:
    nic.funet.fi				pub/OS/Linux
    tsx-11.mit.edu				pub/linux
    tupac-amaru.informatik.rwth-aachen.de	pub/msdos/replace

The current version of Linux is 0.95a released on March 17, 1992

End of Linux-Activists Digest
******************************